/* prosty program demonstracyjny "obsuga 3 cyfr led"
   cyfry LED podczona do portu P0, stan aktywny = L,
   zaczanie cyfr przy pomocy kluczy BS250 podczonych do P1
   rezonator kwarcowy 8MHz
   seg.A = P0.4
   seg.B = P0.3
   seg.C = P0.6
   seg.D = P0.2
   seg.E = P0.5
   seg.F = P0.1
   seg.G = P0.0
   seg.dp = P0.7
   
   cyfra 1 = P1.2
   cyfra 2 = P1.1
   cyfra 3 = P1.0 */
   
#include <reg51.h>						//doczenie definicji rejestrw mikrokontrolera

#define 	PortLED	P0						//port,do ktrego doaczone s segmenty LED
#define	PortSW	P1						//port,do ktrego doczone tranzystory kluczy

#define 	_A			0xEF					//definicje segmentw cyfry
#define 	_B			0xF7
#define 	_C			0xBF
#define 	_D			0xFB
#define 	_E			0xDF
#define 	_F			0xFD
#define 	_G			0xFE
#define 	_H			0x7F

#define	LED_1		0xFE					//kody zaczenia poszczeglnych cyfr wywietlacza
#define	LED_2		0xFD
#define	LED_3		0xFB
#define	LED_off	0xFF

//definicje wygldu cyfr od 0 do 9
char code Digits[10] = { _A & _B & _C & _D & _E & _F,			//0
								 _B & _C,									//1
								 _A & _B & _D & _E & _G,				//2
								 _A & _B & _C & _D & _G,				//3
								 _B & _C & _F & _G,						//4
								 _A & _C & _D & _F & _G,				//5
								 _A & _C & _D & _E & _F & _G,			//6
								 _A & _B & _C,								//7
								 _A & _B & _C & _D & _E & _F & _G,	//8
								 _A & _B & _C & _D & _F & _G };		//9

 
//opnienie okoo 1 sekundy dla kwarcu 8MHz
void Delay(unsigned int time)
{
	unsigned int j;
	
	while (time-- >= 1) for (j=0; j<65; j++);		//ptla FOR jest powtarzana TIME razy
}


//funkcja zwraca cyfr bdc na pozycji POSITION
char Subnumber(unsigned int number, char position)
{
	switch (position)
	{
		case 1:
			return(number / 100);				//cyfra 1 - zwr cz cakowit z dzielenia przez 100
		case 2:
			number %= 100;							//cyfra 2 - dzielenie cakowite przez 10 reszty z 
			return(number / 10);					//dzielenia przez 100
		case 3:
			return(number % 10);					//cyfra 3 - reszta z dzielenia przez 10
		default:
			return(0);								//przypadek zabroniony
			break;
	}
}


//pocztek programu gwnego
void main(void)
{
	unsigned int loop, counter;				//zmienne ptli i licznika
	char i;
	
	while (1)										//ptla nieskoczona
	{
		for (loop = 0; loop < 30; loop++)
		{
			PortLED = Digits[Subnumber(counter,3)];	//zapis kodu cyfry numer 3 do portu
			PortSW = LED_3;						//zaczenie wywietlania cyfry 3
			Delay(20);								//opnienie okoo 20ms
			PortSW = LED_off;						//wyczenie wywietlania

			PortLED = Digits[Subnumber(counter,2)];	//zapis kodu cyfry numer 2 do portu
			PortSW = LED_2;						//zaczenie wywietlania cyfry 2
			Delay(20);								//opnienie okoo 20ms
			PortSW = LED_off;						//wyczenie wywietlania

			PortLED = Digits[Subnumber(counter,1)];	//zapis kodu najstarszej cyfry do portu
			PortSW = LED_1;						//zacznie cyfry numer 1
			Delay(20);								//opnienie okoo 20ms
			PortSW = LED_off;						//wyczenie wywietlania
		}
		counter++;									//zwikszenie licznika o 1
	}
}
  
