/* prosty program demonstracyjny "odczyt klawiatury matrycowej"
   wiersze P1.2 do P1.4, kolumny P1.5 do P1.6 (3x3 = 9 klawiszy)
   rezonator kwarcowy 8MHz */
   
#include <reg51.h>					//doczenie definicji rejestrw mikrokontrolera
#include <stdio.h>					//doczenie prototypu funkcji printf

#define PortKey	P1					//definicja bitu portu klawisza

#define Column_1	0b11111011		//definicje stanw bitw kolumn
#define Column_2	0b11110111
#define Column_3	0b11101111
#define Dummy		0b00011100		//warto dla ustawienia bitw kolumn na "1"

#define Row_1		0b00100000		//definicje pocze bitw wierszy
#define Row_2		0b01000000
#define Row_3		0b10000000

//opnienie okoo 1 milisekundy dla kwarcu 8MHz
void Delay(unsigned int time)
{
	unsigned int j;
	
	while (time >= 1)					//wykonanie ptli FOR zajmuje okoo 1 msek.
	{										//ptla jest powtarzana TIME razy
		for (j=0; j<65; j++);
		time--;
	}
}

//odczyt portu klawiatury
unsigned char PortKeyRead(unsigned char column)
{
	unsigned char curr, prev;
	
	PortKey |= Dummy;					//ustawienie na warto "1" bitw kolumn
	PortKey &= column;				//stan niski kolumny 1
	prev = PortKey;					//odczyt portu klawiatury
	prev &= 0xE0;						//maskowanie wszystkich bitw oprcz wierszy
	if (prev == 0xE0) return (0);	//jeli wszystkie bity s jedynkami dla danej kolumny
											//nie wcinito adnego klawisza
											
	Delay(20);							//eliminacja drga stykw poprzez powtrny odczyt i porwnanie
	curr = PortKey;
	curr &= 0b11100000;
	if (curr == prev) 
	{
		while (prev = curr)			//czekaj na zwolnienia klawisza
		{
			prev = PortKey;
			prev &= 0xE0;
		}
		return(~curr);					//zamiana aktywnych bitw z 0 na 1
	}
	else return(0);					//zwr 0 w przypadku rnic odczytw
}


//odczyt klawiatury podczonej do PortKey
//funkcja zwraca numer wcinitego klawisza
unsigned char KeyNumber()
{
	unsigned char b;
	
	b = PortKeyRead(Column_1);		//odczyt: kolumna 1 - wiersz 1, 2, 3
	if (!b)
	{
		if (b && Row_1) return(3);
		if (b && Row_2) return(6);
		if (b && Row_3) return(9);
	}

	b = PortKeyRead(Column_2);		//odczyt: kolumna 2 - wiersz 1, 2, 3
	if (!b)
	{
		if (b && Row_1) return(2);
		if (b && Row_2) return(5);
		if (b && Row_3) return(8);
	}

	b = PortKeyRead(Column_3);		//odczyt: kolumna 3 - wiersz 1, 2, 3
	if (!b)
	{
		if (b && Row_1) return(1);
		if (b && Row_2) return(4);
		if (b && Row_3) return(7);
	}
	
	return(0);							//nie wcinito adnego klawisza, zwr 0
}


//pocztek programu gwnego
void main(void)
{
	while (1)							//ptla nieskoczona
	{
		char buf = KeyNumber();		//odczyt numeru klawisza poczony z deklaracj buf
		if (!buf) printf("%s\n",buf);	//wysanie numeru klawisza przez RS232
	}
}

