/* prosty program demonstracyjny "przerwanie generowane po wciniciu klawisza"
   wykorzystane s bity P1.0 do P1.4 oraz wejcie zewntrznego przerwania INT0
   rezonator kwarcowy 8MHz */
   
#include <reg51.h>					//doczenie definicji rejestrw mikrokontrolera
#include <stdio.h>					//prototyp funkcji printf

#define PortKey	P1					//definicja bitu portu klawisza
#define Key_1		0b00000001		//maski dla poszczeglnych bitw klawiszy
#define Key_2		0b00000010
#define Key_3		0b00000100
#define Key_4		0b00001000
#define Key_5		0b00010000
#define mask		0b00011111		//maska bitw klawiatury dla operacji logicznych

unsigned char status = 0;			//status klawiatury, ustawianiy w obsudze przerwania


//odczyt klawiatury podczonej do PortKey
//jest to funkcja obsugi przerwania uywajca banku rejestrw 1
void KbdRead() interrupt 1 using 1
{
	int i;
	unsigned char p;

	p = PortKey;						//odczyt bitw portu
	p = ~p & mask;
	for (i=0; i<1300; i++);			//pauza 20 ms dla rezonatora 8MHz
	status = PortKey;					//ponowny odczyt bitw klawiatury dla weryfikacji
	status = ~status & mask;
	if (p != status) status = 0;	//ustawienie zmiennej status
}


//pocztek programu gwnego
void main(void)
{
	PortKey |= ~mask;					//ustawienie linii klawiatury
	EX0 = 1;								//zezwolenie na przyjmowanie przerwa INT0
	EA = 1;								//zaczenie przerwa
	while (1)							//ptla nieskoczona
	{
		if (status)
		{
			if (status && Key_1) printf("%s\n","Klawisz 1");
			if (status && Key_2) printf("%s\n","Klawisz 2");
			if (status && Key_3) printf("%s\n","Klawisz 3");
			if (status && Key_4) printf("%s\n","Klawisz 4");
			if (status && Key_5) printf("%s\n","Klawisz 5");
			status = 0;
		}
	}
}

