#include "reg51.h"
#include "lcd4b.h"
#include "KBD3x4.h"

//odczyt portu klawiatury
char KBD_Read(char column)
{
	char curr, prev;
	
	KeyPort |= Dummy;					//ustawienie na warto "1" bitw kolumn i wierszy
	KeyPort &= column;				//stan niski kolumny uytej jako argument funkcji
	prev = KeyPort;					//odczyt portu klawiatury
	prev &= Row_mask;					//maskowanie wszystkich bitw oprcz wierszy
	if (prev == Row_mask) return (0);	//jeli wszystkie bity s jedynkami dla danej kolumny
											//nie wcinito adnego klawisza
											
	Delay(50);							//eliminacja drga stykw poprzez powtrny odczyt i porwnanie
	curr = KeyPort;					//po czasie 50ms
	curr &= Row_mask;
	if (curr == prev) 
	{
		return(~curr);					//zamiana aktywnych bitw z 0 na 1
	}
	else return(0);					//zwr 0 w przypadku rnic odczytw
}


// funkcja odczytujca klawiatur - matryc 4 (wiersze) x 3 (kolumny)
// zwracany jest kod wcinitego klawisza
// 0x01  0x02  0x03
// 0x04  0x05  0x06
// 0x07  0x08  0x09
// 0x0A  0x0B  0x0C
char Key_Number(void)
{
	char bx;
	
	bx = KBD_Read(Column_1);		//odczyt: kolumna 1 - wiersz 1, 2, 3, 4
	if (bx)
	{
		if (bx & Row_1) return(0x01);
		if (bx & Row_2) return(0x04);
		if (bx & Row_3) return(0x07);
		if (bx & Row_4) return(0x0A);
	}

	bx = KBD_Read(Column_2);		//odczyt: kolumna 2 - wiersz 1, 2, 3, 4
	if (bx)
	{
		if (bx & Row_1) return(0x02);
		if (bx & Row_2) return(0x05);
		if (bx & Row_3) return(0x08);
		if (bx & Row_4) return(0x0B);
	}

	bx = KBD_Read(Column_3);		//odczyt: kolumna 3 - wiersz 1, 2, 3, 4
	if (bx)
	{
		if (bx & Row_1) return(0x03);
		if (bx & Row_2) return(0x06);
		if (bx & Row_3) return(0x09);
		if (bx & Row_4) return(0x0C);
	}
	
	return(0);							//nie wcinito adnego klawisza, zwr 0
}

 
